#!/bin/sh

set -e
set -u

if [ $# -lt 3 ]
then
    echo "$0: invoked with wrong number of parameters"
    echo "usage: PATH_TO_PROGRAM PATH_TO_TEST LOGFILE WORKDIR"
    exit 1
fi

PROG="$1"
TEST="$2"
LOG="$3"
DIR="$4"
shift 4

mkdir -p "$DIR"
cd "$DIR"

TN="`basename $TEST`"

set +e
$TEST "$PROG" "$@" > "$LOG" 2>&1

if [ $? -eq 0 ]
then
    echo "${TN}: passed" | tee -a "$LOG"
else
    echo "${TN}: failed" | tee -a "$LOG"
fi
